<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_DIRECT_PURCHASE_REQ';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/purchasing/includes/ui/direct_purchase_requisitions_ui.inc");
include_once($path_to_root . "/purchasing/includes/db/direct_purchase_requisitions_db.inc");
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/project_cost_functions.inc"); 
include_once($path_to_root . "/includes/approval_functions.inc"); 
include_once($path_to_root . "/services/includes/db/job_orders_db.inc"); 

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if ((isset($_GET['dpr_no']) && is_numeric($_GET['dpr_no'])) || (isset($_POST['dpr_no']) && is_numeric($_POST['dpr_no']))) {
    $dpr_no = $_POST['dpr_no'] = isset($_GET['dpr_no']) ? $_GET['dpr_no'] : $_POST['dpr_no'];
    
    $page_title = _($systypes_array[ST_DIRECT_PURCHASE_REQ]); 
    
} elseif (isset($_GET['ModifyDPR_No']) || isset($_POST['ModifyDPR_No'])) {
    $_POST['ModifyDPR_No'] = isset($_GET['ModifyDPR_No']) ? $_GET['ModifyDPR_No'] : $_POST['ModifyDPR_No'];
    $dpr_no = $_POST['ModifyDPR_No'];
    
    $header = get_direct_purchase_requisition_header_record($dpr_no);
        if (is_array($header)) {
            if ($header['type'] != ST_DIRECT_PURCHASE_REQ) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
            
            $_POST['jo_id'] = $header['jo_id'];
            $trans_no = $header['trans_no'];
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Invalid transaction ID."));
            display_footer_exit();
        }
    
    $page_title = _('Modify '.$systypes_array[ST_DIRECT_PURCHASE_REQ]." #$trans_no" );
    
} elseif ((isset($_GET['jo_id']) && is_numeric($_GET['jo_id'])) || (isset($_POST['jo_id']) && is_numeric($_POST['jo_id']))) {
    $_POST['jo_id'] = isset($_GET['jo_id']) ? $_GET['jo_id'] : $_POST['jo_id'];
    
    $page_title = _('New '.$systypes_array[ST_DIRECT_PURCHASE_REQ]); 
    $dpr_no = 0;
    
} elseif (isset($_GET['type']) && (isset($_GET['ApprovedID']) || isset($_GET['RejectedID']) || isset($_GET['BackedOrgID']))) {
    $page_title = _($systypes_array[$_GET['type']]);
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Invalid transaction type."));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_GET['ApprovedID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['ApprovedID'];
    $trans_type = $_GET['type'];

    $msg = get_session_variable('dpr_messages');
    clear_session_variable('dpr_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('dpr_bo_messages');
    clear_session_variable('dpr_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['RejectedID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('dpr_rj_messages');
    clear_session_variable('dpr_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_POST['Approve_DPR'])) {
    $msg = save_direct_purchase_requisition_header_only($dpr_no, true);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_DPR'])) {
    $msg = back_to_originator_direct_purchase_requisition($dpr_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['REJECT_DPR'])) {
    $msg = reject_direct_purchase_requisition($dpr_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Save_DPR_Header'])) {
    $msg = save_direct_purchase_requisition_header_only($dpr_no);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            $Mode = 'RESET';
        }
}

if (isset($_POST['Add_DPR']) || isset($_POST['Update_DPR'])) {        
    $msg = save_direct_purchase_requisition($dpr_no, $selected_id);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_direct_purchase_requisition_details();
            $Mode = 'RESET';
        }
}

if ($Mode == 'Delete') {
    $msg = delete_direct_purchase_requisition_line($dpr_no, $selected_id);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_direct_purchase_requisition_details();
            $Mode = 'RESET';
        }
}

if (isset($_POST['cancel'])) {
    clear_direct_purchase_requisition_details();
    
    $Mode = 'RESET';
    $selected_id = -1;
}  

if ($Mode == 'RESET') {
    $selected_id = -1;
}

global $Ajax;

start_form();

    if (isset($_POST['jo_id']) && $_POST['jo_id'] > -1) {
        hidden('jo_id', $_POST['jo_id']);
    }    
        
    if (isset($dpr_no) && $dpr_no > 0) {
        hidden('dpr_no', $dpr_no);
    } elseif (isset($_POST['dpr_no']) && $_POST['dpr_no'] > 0) {
        hidden('dpr_no', $_POST['dpr_no']);
        $dpr_no = $_POST['dpr_no'];
    } elseif(isset($_POST['ModifyDPR_No'])) {
        hidden('ModifyDPR_No', $_POST['ModifyDPR_No']);
        $dpr_no = $_POST['ModifyDPR_No'];
    } 

    $Ajax->activate('nsit_header');
    $Ajax->activate('_page_body');
    $Ajax->activate('All_details');
    div_start('All_details');
    
        display_direct_purchase_requisition_header($dpr_no);

        $header = get_direct_purchase_requisition_header($dpr_no);
            if (is_array($header)) {
                submit_center_first('Save_DPR_Header', _("Save Header"), '', 'default');    

                submit('Approve_DPR', _("Release for Approval"), true, _("Release for Approval"), false, ICON_SUBMIT);
            
                submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT);                br(2);
                
                start_table();
                    submit_center_first('REJECT_DPR', _("Reject ".$systypes_array[ST_OUTSIDE_MATERIAL_REQ]), '', true, ICON_DELETE);    

                    submit('BACK_TO_ORIGINATOR_DPR', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                end_table(2);
            }

        display_direct_purchase_requisition_details($dpr_no, $selected_id, $Mode);

    div_end();
    
end_form();
end_page(@$_GET['popup'], false, false);        

?>